// YamaIRC
// Version Alpha 5.0.0.0
//(AlphaVer.MajorUpdateVer.MinorUpdateVer.CurrentBuild)
/* Information
 Created by Yamagushi
 On 7/15/10

 Latest Noted Update
 On 12/11/10*/

#include "main.h"
#ifdef PlatformPSP //Move to YamaLib #DEBUG#
 PSP_MODULE_INFO("YamaIRC", 0, 1, 1);
 PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);
 PSP_HEAP_SIZE_KB(12*1024);
#endif



//Start Program
#ifdef PlatformZune
int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpCmdLine, int nShowCmd)
#endif
#ifdef PlatformPSP
int main(int argc, char **argv)
#endif
{	
	#ifdef PlatformZune
	 //Timeout Fix Part 1 of 3
	 void *TimeOutFixbuffer=malloc(0x24|0xA00);
	 void *TimeOutFixrbuff=malloc(1000);
	 int TimeOutFixframeskip = 0;
	#endif

	ylSetupCallbacks();   //Setup Callbacks.
	InitYamaLib();   //Initilization of YamaLib.
	EngineInit();   //Initilization of the YamaIRC Engine.
		
	while(!YL_QUIT) {
	
			//Wifi #ASDFG#
			//ZDKCloud_ShowConnectivityWizard();	
	
	
		//Controls
		ylReadInput();   //Read Input	
		#ifdef PlatformPSP
		 if ((!Keyboard.isactive) && (!(lastinput.Buttons & PSP_CTRL_START)) && (input.Buttons & PSP_CTRL_START)){
			if (!Settings.isactive) { Settings.isactive = 1; PauseMenu.level = 0; PauseMenu.selected = 0; }
			else { Settings.isactive = 0; PauseMenu.level = 0; PauseMenu.selected = 0; }		
		 } else
		#endif 
		#ifdef PlatformZune
		 //Settings Button
		 if ((!Keyboard.isactive) && (input.TouchState.Count == 1) &&  (lastinput.TouchState.Count == 0) && 
		 (input.TouchState.Locations[0].X >= ylEngine.scwidth - Cursor1.sizeX) && (input.TouchState.Locations[0].X <= ylEngine.scwidth) && 
		 (input.TouchState.Locations[0].Y >= 0) && (input.TouchState.Locations[0].Y <= Cursor1.sizeY)) {			 
			if (!Settings.isactive) { 
				Settings.isactive = 1; PauseMenu.level = 0; PauseMenu.selected = 0; UI.settingsscroll = 0; UI.settingspos = 0; UI.settingsoffset = 0; UI.settingscuroffset = 0;
			}			
			else {
				if (PauseMenu.level > 0) {  
					if (PauseMenu.level == 3) { PauseMenu.level = 0; }
					else { PauseMenu.level--; }
					PauseMenu.selected = 0; UI.settingsscroll = 0; UI.settingspos = 0; UI.settingsoffset = 0; UI.settingscuroffset = 0; }
				else { Settings.isactive = 0; PauseMenu.level = 0; PauseMenu.selected = 0; UI.settingsscroll = 0; UI.settingspos = 0; UI.settingsoffset = 0; UI.settingscuroffset = 0;  }	
			}
		 }	
		 //Home Button Quit
		 else if (ZDKExt_ExitRequested()) { 			
			raw("QUIT :YamaIRC\r\n");
			LogChat(-3, 2, NULL, NULL, NULL, NULL, "Closing Engine.", NULL);
			Sleep(1*1000);				
			YL_QUIT = 1;   //Quits the Engine.
		 } else 
		#endif 		
		if (PopUp.isactive) { PopUpControls(); } //If PopUp is Active, Run PopUp Controls.
		else if (!Settings.isactive) {   //If Settings is not Active, Run Normal Controls.
			if (Settings.runonce) {	MenuControls();	}   //Controls for the Original Menu.
			else {	IRCControls();	}   //Controls for the IRC.
		} else { SettingsControls(); }   //If Settings is Active, Run Only Settings Controls.
	
		//Engine
		#ifdef PlatformZune
		 ZDKCloud_IsConnected(&Network.wlan);   //Checks Wifi Connection
		#endif
		#ifdef PlatformPSP
		 Network.wlan = oslIsWlanConnected();   //Checks Wifi Connection
		#endif
		if (!Network.wlan) { Network.status = 0; }
		if (++Engine.frameskip >= 10) {   //Set Engine Frameskip.
			if (Network.status == 1) { IRCUpdate(); }   //Update Engine.
			Engine.frameskip = 0;   //Reset Engine Frameskip.
		}	
		if (++Network.activityfs >= 20) {   //Set Network Activity Frameskip.
			Network.activity = 0;   //Reset  Network Activity.
			Network.activityfs = 0;   //Reset Network Activity Frameskip.
		}	
		
		//UI
		ylStartDrawing();   //Start Current Frame.		
		ylClearScreen();   //Clear Screen for New Frame.	
		if (Settings.runonce) {	MenuUI();}   //Run Starting Menu UI. Shitty Method. #DEBUG#
		else { IRCUI(); }   //Run Chat Menu UI.		
		if (Settings.isactive) { SettingsUI(); }   //If Settings Menu is Active Run its UI.	
		if (PopUp.isactive) { PopUpUI(); }   //If PopUp Menu is Active Run its UI.	
		
		
		
		if (!Network.wlan) {
			ylDrawImageAdv(&Cursor1, Cursor1.X, Cursor1.Y, Cursor1.sizeX, Cursor1.sizeY, Cursor1.R, ylEngine.horizontal, 0.0f, 1.0f, 0.0f, 1.0f, colors.RED);   //Draw Cursor 1
		} else {
			ylDrawImageAdv(&Cursor1, Cursor1.X, Cursor1.Y, Cursor1.sizeX, Cursor1.sizeY, Cursor1.R, ylEngine.horizontal, 0.0f, 1.0f, 0.0f, 1.0f, colors.GREEN);   //Draw Cursor 1
		}
		
		if (++Cursor2.R > 360) { Cursor2.R-=360; }   //Rotate Cursor 2		
		if (!Network.status) {
			ylDrawImageAdv(&Cursor2, Cursor2.X, Cursor2.Y, Cursor2.sizeX, Cursor2.sizeY, Cursor2.R, ylEngine.horizontal, 0.0f, 1.0f, 0.0f, 1.0f, colors.RED);   //Draw Cursor 2
		} else {
			ylDrawImageAdv(&Cursor2, Cursor2.X, Cursor2.Y, Cursor2.sizeX, Cursor2.sizeY, Cursor2.R, ylEngine.horizontal, 0.0f, 1.0f, 0.0f, 1.0f, colors.BLUE);   //Draw Cursor 2
		}
		
		if (--Cursor3.R < 0) { Cursor3.R+=360; }   //Rotate Cursor 3		
		if (!Network.activity) {
			ylDrawImageAdv(&Cursor3, Cursor3.X, Cursor3.Y, Cursor3.sizeX, Cursor3.sizeY, Cursor3.R, ylEngine.horizontal, 0.0f, 1.0f, 0.0f, 1.0f, colors.RED);   //Draw Cursor 2
		} else {
			ylDrawImageAdv(&Cursor3, Cursor3.X, Cursor3.Y, Cursor3.sizeX, Cursor3.sizeY, Cursor3.R, ylEngine.horizontal, 0.0f, 1.0f, 0.0f, 1.0f, colors.YELLOW);   //Draw Cursor 2
		}
		
		
		if (Keyboard.isactive) { RunKeyboard(); }   //If Keyboard is active Run it.		
		ylEndDrawing();   //End Drawing.
		ylSyncFrame();   //End Current Frame.
			

		
		#ifdef PlatformZune
		 //Timeout Fix Part 2 of 3
		 TimeOutFixframeskip++;
		 if (TimeOutFixframeskip == 90) { ZDKSystem_SignalUserActivity(); }
		 if (TimeOutFixframeskip >= 180) {
			ZDKSystem_SignalUserActivity();
			ZDKCloud_CreateWebDownloadTask(0,L"http://www.google.com",TimeOutFixbuffer,1,TimeOutFixrbuff);
			TimeOutFixframeskip = 0;
		 }
		#endif

		OpenChannel->newmessage = 0;   //Clear New Message Alert
	}		
	
	QuitEngine();   //Quits the Engine.
	
	#ifdef PlatformZune
	 //Timeout Fix Part 3 of 3
	 free(TimeOutFixbuffer);
	 free(TimeOutFixrbuff);
	#endif
	
	UnitYamaLib();   //Unit YamaLib.
	return 0;   //End Program.
}